<?php
if (!defined('_PS_VERSION_'))
	exit;

class HomecategoriesPlus extends Module
{
	private $_html = '';
	private $_postErrors = array();

	public function __construct()
	{
		$this->name = 'homecategoriesplus';
		$this->tab = 'front_office_features';
		$this->version = 0.7;
		$this->author = 'ckarone';
		$this->need_instance = 0;

		parent::__construct();  // The parent construct 

		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('Homepage Category Plus');
		$this->description = 'Display categories, sub-categories & product(s) on your homepage.';
		
				if (!$this->isRegisteredInHook('header'))
			$this->registerHook('header');
	}
	
	function install()
	{
		if (!Configuration::updateValue('HOME_cat_plus__NBR', 10) 
		OR !Configuration::updateValue('HOME_cat_plus__NBR_sub', 8) 
		OR !Configuration::updateValue('HOME_cat_plus__NBR_size', 278) 
		OR !Configuration::updateValue('HOME_cat_plus__NBR_size_h', 250) 
		OR !Configuration::updateValue('HOME_cat_plus__NBR_marge_p', 10) 
		OR !Configuration::updateValue('HOME_cat_plus__NBR_size_l', '333333') 
		OR !Configuration::updateValue('HOME_cat_plus__product', '1') 
		OR !Configuration::updateValue('HOME_cat_plus__cat', '1') 
		OR !Configuration::updateValue('HOME_cat_plus__cat_img', '0') 
		OR !Configuration::updateValue('HOME_cat_plus__subcat_img', '0') 
		OR !Configuration::updateValue('HOME_cat_plus__product_odr', '1')
		OR !Configuration::updateValue('HOME_cat_plus__product_btn', '1')
		OR !Configuration::updateValue('HOME_cat_plus__product_price', '1')
		OR !Configuration::updateValue('HOME_cat_plus__product_b', '0')
		OR !Configuration::updateValue('HOME_cat_plus__product_bc', '0')
		OR !Configuration::updateValue('HOME_cat_plus__blockb', '0')
		OR !Configuration::updateValue('HOME_cat_plus__blockbc', '333333')
		OR !Configuration::updateValue('HOME_cat_plus__sub1', '000000')
		OR !Configuration::updateValue('HOME_cat_plus__sub2', '000000')
		OR !Configuration::updateValue('HOME_cat_plus__sub3', '120')
		OR !Configuration::updateValue('HOME_cat_plus__sub4', '10')
		OR !Configuration::updateValue('HOME_cat_plus__sub5', '1')
		OR !Configuration::updateValue('HOME_cat_plus__sub6', 'ffffff')
		OR !Configuration::updateValue('HOME_cat_plus__sub7', '1')
		OR !Configuration::updateValue('HOME_cat_plus__sub8', '333333')
		OR !Configuration::updateValue('HOME_cat_plus__sub9', '180')
		OR !Configuration::updateValue('HOME_cat_plus__sub10', '1')
		OR !Configuration::updateValue('HOME_cat_plus__sub11', '110')
		OR !Configuration::updateValue('HOME_cat_plus__sub12', '170')
		OR !Configuration::updateValue('HOME_cat_plus__sub13', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub14', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub15', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub16', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub17', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub18', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub19', '0')
		OR !Configuration::updateValue('HOME_cat_plus__sub20', '0')
		OR !Configuration::updateValue('HOME_cat_plus__NBR_mw', '770')
		OR !Configuration::updateValue('HOME_cat_plus__selcat', '0')
		OR !parent::install() 
		OR !$this->registerHook('home'))
			return false;
		return true;
	}

	function uninstall()
	{
		if (!parent::uninstall()
		OR !Configuration::deleteByName('HOME_cat_plus__NBR')
		OR !Configuration::deleteByName('HOME_cat_plus__NBR_sub')
		OR !Configuration::deleteByName('HOME_cat_plus__NBR_size')
		OR !Configuration::deleteByName('HOME_cat_plus__NBR_size_h')
		OR !Configuration::deleteByName('HOME_cat_plus__NBR_marge_p')
		OR !Configuration::deleteByName('HOME_cat_plus__NBR_size_l')
		OR !Configuration::deleteByName('HOME_cat_plus__product')
		OR !Configuration::deleteByName('HOME_cat_plus__cat')
		OR !Configuration::deleteByName('HOME_cat_plus__cat_img')
		OR !Configuration::deleteByName('HOME_cat_plus__subcat_img')
		OR !Configuration::deleteByName('HOME_cat_plus__product_odr')
		OR !Configuration::deleteByName('HOME_cat_plus__product_btn')
		OR !Configuration::deleteByName('HOME_cat_plus__product_price')
		OR !Configuration::deleteByName('HOME_cat_plus__product_b')
		OR !Configuration::deleteByName('HOME_cat_plus__product_bc')
		OR !Configuration::deleteByName('HOME_cat_plus__blockb')
		OR !Configuration::deleteByName('HOME_cat_plus__blockbc')
		OR !Configuration::deleteByName('HOME_cat_plus__sub1')
		OR !Configuration::deleteByName('HOME_cat_plus__sub2')
		OR !Configuration::deleteByName('HOME_cat_plus__sub3')
		OR !Configuration::deleteByName('HOME_cat_plus__sub4')
		OR !Configuration::deleteByName('HOME_cat_plus__sub5')
		OR !Configuration::deleteByName('HOME_cat_plus__sub6')
		OR !Configuration::deleteByName('HOME_cat_plus__sub7')
		OR !Configuration::deleteByName('HOME_cat_plus__sub8')
		OR !Configuration::deleteByName('HOME_cat_plus__sub8')
		OR !Configuration::deleteByName('HOME_cat_plus__sub9')
		OR !Configuration::deleteByName('HOME_cat_plus__sub10')
		OR !Configuration::deleteByName('HOME_cat_plus__sub11')
		OR !Configuration::deleteByName('HOME_cat_plus__sub12')
		OR !Configuration::deleteByName('HOME_cat_plus__sub13')
		OR !Configuration::deleteByName('HOME_cat_plus__sub14')
		OR !Configuration::deleteByName('HOME_cat_plus__sub15')
		OR !Configuration::deleteByName('HOME_cat_plus__sub16')
		OR !Configuration::deleteByName('HOME_cat_plus__sub17')
		OR !Configuration::deleteByName('HOME_cat_plus__sub18')
		OR !Configuration::deleteByName('HOME_cat_plus__sub19')
		OR !Configuration::deleteByName('HOME_cat_plus__sub20')
		OR !Configuration::deleteByName('HOME_cat_plus__selcat')
		OR !Configuration::deleteByName('HOME_cat_plus__NBR_mw'))
			return false;
		return true;
	}

	function getContent()
	{
		$output = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitHomecategoriesplus'))
		{
			$nbrp_prod_ord = Tools::getValue('nbrp_prod_ord');
			$nbrp_prod_btn = Tools::getValue('nbrp_prod_btn');
			$nbrp_prod_price = Tools::getValue('nbrp_prod_price');
			$nbrp_prod = Tools::getValue('nbrp_prod');
			$nbrp_prod_bord = Tools::getValue('nbrp_prod_bord');
			$nbrp_prod_bordc = Tools::getValue('nbrp_prod_bordc');
			$nbrp_blockb = Tools::getValue('nbrp_blockb');
			$nbrp_blockbc = Tools::getValue('nbrp_blockbc');
			$nbrp_cat_img = Tools::getValue('nbrp_cat_img');
			$nbrp_subcat_img = Tools::getValue('nbrp_subcat_img');
			$nbrp_cat = Tools::getValue('nbrp_cat');
			$nbrp_sub1 = Tools::getValue('nbrp_sub1');
			$nbrp_sub2 = Tools::getValue('nbrp_sub2');
			$nbrp_sub3 = Tools::getValue('nbrp_sub3');
			$nbrp_sub4 = Tools::getValue('nbrp_sub4');
			$nbrp_sub5 = Tools::getValue('nbrp_sub5');
			$nbrp_sub6 = Tools::getValue('nbrp_sub6');
			$nbrp_sub7 = Tools::getValue('nbrp_sub7');
			$nbrp_sub8 = Tools::getValue('nbrp_sub8');
			$nbrp_sub9 = Tools::getValue('nbrp_sub9');
			$nbrp_sub10 = Tools::getValue('nbrp_sub10');
			$nbrp_sub11 = Tools::getValue('nbrp_sub11');
			$nbrp_sub12 = Tools::getValue('nbrp_sub12');
			$nbrp_sub13 = Tools::getValue('nbrp_sub13');
			$nbrp_sub14 = Tools::getValue('nbrp_sub14');
			$nbrp_sub15 = Tools::getValue('nbrp_sub15');
			$nbrp_sub16 = Tools::getValue('nbrp_sub16');
			$nbrp_sub17 = Tools::getValue('nbrp_sub17');
			$nbrp_sub18 = Tools::getValue('nbrp_sub18');
			$nbrp_sub19 = Tools::getValue('nbrp_sub19');
			$nbrp_sub20 = Tools::getValue('nbrp_sub20');
			$nbrp_sub21 = Tools::getValue('nbrp_sub21');
			$nbrp_mw = Tools::getValue('nbrp_mw');
			$nbrp_marge_p = Tools::getValue('nbrp_marge_p');
			
			$nbrp = Tools::getValue('nbrp');
			if (!$nbrp)
				$errors[] = $this->l('Invalid number of categories');

			$nbrp_sub = Tools::getValue('nbrp_sub');
			if (!$nbrp_sub)
				$errors[] = $this->l('Invalid number of subcategories');

			$nbrp_size = Tools::getValue('nbrp_size');
			if (!$nbrp_size)
				$errors[] = $this->l('Invalid number for Categories block size ');
				
			$nbrp_size_h = Tools::getValue('nbrp_size_h');
			if (!$nbrp_size_h)
				$errors[] = $this->l('Invalid number for Categories block size h ');

			$nbrp_size_l = Tools::getValue('nbrp_size_l');
			if (!$nbrp_size_l)
				$errors[] = $this->l('Invalid number for title categories background color');
		   
		   	$nbrp_sub10 = Tools::getValue('nbrp_sub10');
			if (!$nbrp_sub10 OR $nbrp_sub10 <= 0)
				$errors[] = $this->l('Invalid number for title product quantity');

			else
				Configuration::updateValue('HOME_cat_plus__NBR', $nbrp);
				Configuration::updateValue('HOME_cat_plus__NBR_sub', $nbrp_sub);
				Configuration::updateValue('HOME_cat_plus__NBR_size', $nbrp_size);
				Configuration::updateValue('HOME_cat_plus__NBR_size_h', $nbrp_size_h);
				Configuration::updateValue('HOME_cat_plus__NBR_marg_p', $nbrp_marge_p);
				Configuration::updateValue('HOME_cat_plus__NBR_size_l', $nbrp_size_l);
				Configuration::updateValue('HOME_cat_plus__product', $nbrp_prod);
				Configuration::updateValue('HOME_cat_plus__cat', $nbrp_cat);
				Configuration::updateValue('HOME_cat_plus__blockb', $nbrp_blockb);
				Configuration::updateValue('HOME_cat_plus__blockbc', $nbrp_blockbc);
				Configuration::updateValue('HOME_cat_plus__cat_img', $nbrp_cat_img);
				Configuration::updateValue('HOME_cat_plus__subcat_img', $nbrp_subcat_img);
				Configuration::updateValue('HOME_cat_plus__product_odr', $nbrp_prod_ord);
				Configuration::updateValue('HOME_cat_plus__product_btn', $nbrp_prod_btn);
				Configuration::updateValue('HOME_cat_plus__product_price', $nbrp_prod_price);
				Configuration::updateValue('HOME_cat_plus__product_b', $nbrp_prod_bord);
				Configuration::updateValue('HOME_cat_plus__product_bc', $nbrp_prod_bordc);
				Configuration::updateValue('HOME_cat_plus__sub1', $nbrp_sub1);
				Configuration::updateValue('HOME_cat_plus__sub2', $nbrp_sub2);
				Configuration::updateValue('HOME_cat_plus__sub3', $nbrp_sub3);
				Configuration::updateValue('HOME_cat_plus__sub4', $nbrp_sub4);
				Configuration::updateValue('HOME_cat_plus__sub5', $nbrp_sub5);
				Configuration::updateValue('HOME_cat_plus__sub6', $nbrp_sub6);
				Configuration::updateValue('HOME_cat_plus__sub7', $nbrp_sub7);
				Configuration::updateValue('HOME_cat_plus__sub8', $nbrp_sub8);
				Configuration::updateValue('HOME_cat_plus__sub9', $nbrp_sub9);
				Configuration::updateValue('HOME_cat_plus__sub10', $nbrp_sub10);
				Configuration::updateValue('HOME_cat_plus__sub11', $nbrp_sub11);
				Configuration::updateValue('HOME_cat_plus__sub12', $nbrp_sub12);
				Configuration::updateValue('HOME_cat_plus__sub13', $nbrp_sub13);
				Configuration::updateValue('HOME_cat_plus__sub14', $nbrp_sub14);
				Configuration::updateValue('HOME_cat_plus__sub15', $nbrp_sub15);
				Configuration::updateValue('HOME_cat_plus__sub16', $nbrp_sub16);
				Configuration::updateValue('HOME_cat_plus__sub17', $nbrp_sub17);
				Configuration::updateValue('HOME_cat_plus__sub18', $nbrp_sub18);
				Configuration::updateValue('HOME_cat_plus__sub19', $nbrp_sub19);
				Configuration::updateValue('HOME_cat_plus__sub20', $nbrp_sub20);
				Configuration::updateValue('HOME_cat_plus__selcat', $nbrp_sub21);
				Configuration::updateValue('HOME_cat_plus__NBR_mw', $nbrp_mw);
			if (isset($errors) AND sizeof($errors))
				$output .= $this->displayError(implode('<br />', $errors));
			else
				$output .= $this->displayConfirmation($this->l('Settings updated'));
		}
		
		return $output.$this->_displayForm();
		
	}

	private function _displayForm()
	{
		$output = $this->_displayDon();
		$output .= $this->_displayCredits();
		
		if(Configuration::get('HOME_cat_plus__sub13') ==1){
		$hideprod ='style="display:none"';
		$hideother ='';
		}else {
		$hideprod ='';
		$hideother ='style="display:none"';
		}
		$output.= '
		<style type="text/css">
		.box{margin:2px;
			border: solid 1px #ccc;
			float:left;
			min-height:170px;
			width:281px;
			padding:1px}
		.box label{font-weight:normal;width: 200px;	padding: 0.1em 0.3em 0 0}
		.box input{margin:1px;height}
  		.box h1{background:#ccc;margin-bottom:2px;font-size:1.2em;}
		</style>
		
		<link rel="stylesheet" media="screen" type="text/css" href="'.$this->_path.'css/colorpicker.css" />
		<script type="text/javascript" src="'.$this->_path.'js/colorpicker.js"></script>
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		
			<fieldset class="width3" ><legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
			<p> <img src="'.$this->_path.'alert.png" width="32px" height="32px" alt="" />'.$this->l('Don\'t forget to create a image called "medium" with a width and a height of 80*80px available for categories and products').'</p>
				<div class="box">
				<h1>'.$this->l('General').'</h1>
				<br><label>'.$this->l('Module width (W in px)').':</label>				
				<input type="text" size="6" name="nbrp_mw" value="'.Tools::getValue('nbrp_mw', Configuration::get('HOME_cat_plus__NBR_mw')).'" />
				<br><label>'.$this->l('Number of cat.').':</label>				
				<input type="text" size="6" name="nbrp" value="'.Tools::getValue('nbrp', Configuration::get('HOME_cat_plus__NBR')).'" />
				<br><label>'.$this->l('Nb of sub cat.').':</label>				
				<input type="text" size="6" name="nbrp_sub" value="'.Tools::getValue('nbrp_sub', Configuration::get('HOME_cat_plus__NBR_sub')).'" />
				<br><label>'.$this->l('Product quantity').':</label>				
				<input type="text" size="6" name="nbrp_sub10" value="'.Tools::getValue('nbrp_sub10', Configuration::get('HOME_cat_plus__sub10')).'" />
				<br><label>'.$this->l('Hidden categories').'*:<br></label>	
				<input type="text" size="6" name="nbrp_sub21" value="'.Tools::getValue('nbrp_sub21', Configuration::get('HOME_cat_plus__selcat')).'" />	';
				
				if(substr(_PS_VERSION_, 0, 3) == '1.4')
				$output .='<br><label>'.$this->l('Animation').':</label><input type="checkbox" name="nbrp_sub13" '.(Tools::getValue('$nbrp_sub13', Configuration::get('HOME_cat_plus__sub13')) ? 'checked="checked"' : '').'value="1" />';
				
				$output .='
				<br><br>*<span style="font-size:0.8em" >'.$this->l('Categories id with comma separated').'</span></div>
				<div '.$hideother.' class="box">
				<h1>'.$this->l('Animation').'</h1>
				<br><label>'.$this->l('Height (H in px)').':</label>				
				<input type="text" size="6" name="nbrp_sub15" value="'.Tools::getValue('$nbrp_sub15', Configuration::get('HOME_cat_plus__sub15')).'" />
				<br><label >'.$this->l('Turn on JQUERY 1.8.3*').':</label>	
				<input type="checkbox" name="nbrp_sub14" '.(Tools::getValue('$nbrp_sub14', Configuration::get('HOME_cat_plus__sub14')) ? 'checked="checked"' : '').'value="1" />
				<br><label>'.$this->l('Side sub-cat. padding (in px)').':</label>				
				<input type="text" size="6" name="nbrp_sub16" value="'.Tools::getValue('$nbrp_sub16', Configuration::get('HOME_cat_plus__sub16')).'" />
				<br><label>'.$this->l('Bar color').':</label>				
				<input type="text" size="6" id="colorpickerField9" name="nbrp_sub17" value="'.Tools::getValue('$nbrp_sub17', Configuration::get('HOME_cat_plus__sub17')).'" />
				<br><label>'.$this->l('Bar thickness').':</label>				
				<input type="text" size="6" name="nbrp_sub18" value="'.Tools::getValue('$nbrp_sub18', Configuration::get('HOME_cat_plus__sub18')).'" />
				<br><br>
				<span style="font-size:0.8em" >'.$this->l('*Only if you have animation problem').'</span><br><br>
				<span style="font-size:0.8em" >'.$this->l('Do not overload your home page with too many pictures!').'</span>
				</div>
				<div class="box">
				<h1>'.$this->l('Top categories').'</h1>
				<br><label>'.$this->l('Cat. size block  (W in px)').':1</label>				
				<input type="text" size="6" name="nbrp_size" value="'.Tools::getValue('nbrp_size', Configuration::get('HOME_cat_plus__NBR_size')).'" />
				<br><label>'.$this->l('Cat. size block  (H in px)').':2</label>				
				<input type="text" size="6" name="nbrp_size_h" value="'.Tools::getValue('nbrp_size_h', Configuration::get('HOME_cat_plus__NBR_size_h')).'" />
				<br><label>'.$this->l('Border (in px)').':</label>				
				<input type="text" size="6" name="nbrp_blockb" value="'.Tools::getValue('nbrp_blockb', Configuration::get('HOME_cat_plus__blockb')).'" />
				<br><label>'.$this->l('Border color').':</label>				
				<input type="text" size="6" name="nbrp_blockbc" id="colorpickerField2" value="'.Tools::getValue('nbrp_blockbc', Configuration::get('HOME_cat_plus__blockbc')).'" />
				<br><label>'.$this->l('Link color').':</label>				
				<input type="text" size="6" id="colorpickerField8" name="nbrp_sub19" value="'.Tools::getValue('$nbrp_sub19', Configuration::get('HOME_cat_plus__sub19')).'" />
				<br><label>'.$this->l('Link color effect').':</label>				
				<input type="text" size="6" id="colorpickerField10" name="nbrp_sub20" value="'.Tools::getValue('$nbrp_sub20', Configuration::get('HOME_cat_plus__sub20')).'" />
				<br><label>'.$this->l('Title background color').':4</label>				
				<input type="text" size="6" name="nbrp_size_l" id="colorpickerField1" value="'.Tools::getValue('nbrp_size_l', Configuration::get('HOME_cat_plus__NBR_size_l')).'" />
				<br><label>'.$this->l('Display image').':</label>				
				<input type="checkbox" name="nbrp_cat_img" '.(Tools::getValue('nbrp_cat_img', Configuration::get('HOME_cat_plus__cat_img')) ? 'checked="checked"' : '').'value="1" />				
				</div>
				<div  '.$hideprod.' class="box">
				<h1>'.$this->l('Product').'</h1>
				<br><label>'.$this->l('Display product').':</label>				
				<input type="checkbox" name="nbrp_prod" '.(Tools::getValue('nbrp_prod', Configuration::get('HOME_cat_plus__product')) ? 'checked="checked"' : '').'value="1" />
				<br><label>'.$this->l('Box width in px').':</label>				
				<input type="text" size="6" name="nbrp_sub11" value="'.Tools::getValue('nbrp_sub11', Configuration::get('HOME_cat_plus__sub11')).'" />
				<br><label>'.$this->l('Box height in px').':</label>				
				<input type="text" size="6" name="nbrp_sub12" value="'.Tools::getValue('nbrp_sub12', Configuration::get('HOME_cat_plus__sub12')).'" />
				<br><label>'.$this->l('Display by').':</label>		
				<select name="nbrp_prod_ord" style="width:68px">	
				<option value="1" '.(Tools::getValue('nbrp_prod_ord', Configuration::get('HOME_cat_plus__product_odr'))== 1 ? 'selected': '').'>'.$this->l('New').'</option>	
				<option value="2" '.(Tools::getValue('nbrp_prod_ord', Configuration::get('HOME_cat_plus__product_odr'))== 2 ? 'selected': '').'>'.$this->l('Position').'</option>	
				<option value="3" '.(Tools::getValue('nbrp_prod_ord', Configuration::get('HOME_cat_plus__product_odr'))== 3 ? 'selected': '').'>'.$this->l('Shuffle').'</option>	
				<option value="4" '.(Tools::getValue('nbrp_prod_ord', Configuration::get('HOME_cat_plus__product_odr'))== 4 ? 'selected': '').'>'.$this->l('Update').'</option>	
				</select>
				<br><label>'.$this->l('Display "add to cart"').':</label>				
				<input type="checkbox" name="nbrp_prod_btn" '.(Tools::getValue('nbrp_prod_btn', Configuration::get('HOME_cat_plus__product_btn')) ? 'checked="checked"' : '').' value="1" />
				<br><label>'.$this->l('Display price').':</label>				
				<input type="checkbox" name="nbrp_prod_price" '.(Tools::getValue('nbrp_prod_price', Configuration::get('HOME_cat_plus__product_price')) ? 'checked="checked"' : '').'value="1" />
				<br><label>'.$this->l('Border (in px)').':</label>				
				<input type="text" size="6" name="nbrp_prod_bord" value="'.Tools::getValue('nbrp_prod_bord', Configuration::get('HOME_cat_plus__product_b')).'" />
				<br><label>'.$this->l('Border color').':</label>				
				<input type="text" size="6" name="nbrp_prod_bordc" id="colorpickerField4" value="'.Tools::getValue('nbrp_prod_bordc', Configuration::get('HOME_cat_plus__product_bc')).'" />
				<br><label>'.$this->l('Margin right (in px)').':3</label>				
				<input type="text" size="6" name="nbrp_marge_p" value="'.Tools::getValue('nbrp_marge_p', Configuration::get('HOME_cat_plus__NBR_marg_p')).'" />
  				</div>
				<div class="box">
				<h1>'.$this->l('Subcategories').'</h1>
				<br><label>'.$this->l('Display subcategories').':</label>				
				<input type="checkbox" name="nbrp_cat" '.(Tools::getValue('nbrp_cat', Configuration::get('HOME_cat_plus__cat')) ? 'checked="checked"' : '').' value="1" />
				<br><label>'.$this->l('Link color').':</label>				
				<input type="text" size="6" name="nbrp_sub1" id="colorpickerField3" value="'.Tools::getValue('nbrp_sub1', Configuration::get('HOME_cat_plus__sub1')).'" />
				<br><label>'.$this->l('Background hover effect').':</label>				
				<input type="text" size="6" name="nbrp_sub2" id="colorpickerField5" value="'.Tools::getValue('nbrp_sub2', Configuration::get('HOME_cat_plus__sub2')).'" />
				<br><label>'.$this->l('Link hover effect').':</label>				
				<input type="text" size="6" name="nbrp_sub6" id="colorpickerField6" value="'.Tools::getValue('nbrp_sub6', Configuration::get('HOME_cat_plus__sub6')).'" />
				<br><label>'.$this->l('Widht (in px)').':</label>				
				<input type="text" size="6" name="nbrp_sub9" value="'.Tools::getValue('nbrp_sub9', Configuration::get('HOME_cat_plus__sub9')).'" />
				<br><label>'.$this->l('Max. of characters').':</label>				
				<input type="text" size="6" name="nbrp_sub3" value="'.Tools::getValue('nbrp_sub3', Configuration::get('HOME_cat_plus__sub3')).'" />
				<br><label>'.$this->l('Font size').':</label>				
				<input type="text" size="6" name="nbrp_sub4" value="'.Tools::getValue('nbrp_sub4', Configuration::get('HOME_cat_plus__sub4')).'" />
				<br style="clear:left"><label>'.$this->l('Link underline').':</label>				
				<input type="checkbox" name="nbrp_sub5" '.(Tools::getValue('nbrp_sub5', Configuration::get('HOME_cat_plus__sub5')) ? 'checked="checked"' : '').'value="1" />
				<br style="clear:left"><label>'.$this->l('Display top category link').':</label>				
				<input type="checkbox" name="nbrp_sub7" '.(Tools::getValue('nbrp_sub7', Configuration::get('HOME_cat_plus__sub7')) ? 'checked="checked"' : '').'value="1" />
				<br style="clear:left"><label>'.$this->l('Category color link').':</label>				
				<input type="text" size="6" name="nbrp_sub8" id="colorpickerField7" value="'.Tools::getValue('nbrp_sub8', Configuration::get('HOME_cat_plus__sub8')).'" />
				<br><label>'.$this->l('Display sub-cat images').':</label>				
				<input type="checkbox" name="nbrp_subcat_img" '.(Tools::getValue('nbrp_subcat_img', Configuration::get('HOME_cat_plus__subcat_img')) ? 'checked="checked"' : '').'value="1" />				
				</div>
		<input type="submit" name="submitHomecategoriesplus" value="'.$this->l('Save configuration').'" class="button" />
		</fieldset>
		</form>
		<script type="text/javascript">
		$(\'#colorpickerField1, #colorpickerField2, #colorpickerField3, #colorpickerField4, #colorpickerField5, #colorpickerField6, #colorpickerField7, #colorpickerField8, #colorpickerField9, #colorpickerField10\').ColorPicker({
		onSubmit: function(hsb, hex, rgb, el) {
		$(el).val(hex);
		$(el).ColorPickerHide();
		},
		onBeforeShow: function () {
		$(this).ColorPickerSetColor(this.value);
		}
		})
		.bind(\'keyup\', function(){
		$(this).ColorPickerSetColor(this.value);
		});
		</script>';
		return $output;
	}

  	private function _displayDon()
	{
	$output  = '
		<center>
			<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
				<fieldset>
					<legend>'.$this->l('Donnation').'</legend>
					<p>'.$this->l('If you like and use the module, Buy me a beer!').'</p>
					<input type="hidden" name="cmd" value="_s-xclick">
					<input type="hidden" name="hosted_button_id" value="5K4EKEZCH86DC">
					<input type="image" src="https://www.paypalobjects.com/fr_FR/FR/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - la solution de paiement en ligne la plus simple et la plus scurise !">
					<img alt="" border="0" src="https://www.paypalobjects.com/fr_FR/i/scr/pixel.gif" width="1" height="1">
					</fieldset>
				</form>
			</center>';			
		return $output;			
	}

	private function _displayCredits()
	{
		$output = '<br class="clear" /><br/>
		<form action="#" method="post" style="float: right; width: 250px;margin-right:25px">
			<fieldset class="widthfull">
				<legend>'.$this->l('Credits').'</legend>
				<p>Homecategoriesplus '.$this->l('by').' <strong>Ckarone</strong></p>
				<p>'.$this->l('Display categories, sub-categories & one product on your homepage.').'
				<p><a href="http://www.prestashop.com/forums/topic/208581-module-gratuit-homecategoriesplus-affichez-vos-categories-et-sous-categories-sur-la-home/">
						'.$this->l('FR post.').'</a>
					<a href="http://www.prestashop.com/forums/topic/210495-free-module-homecategoryplus-display-your-categories-and-subcategories-on-the-home/">
						'.$this->l('UK post.').'</a>
				</p>
				<p>'.$this->l('JQUERY animation powered by tympanus.net').' : <a href="http://tympanus.net/codrops/2012/12/31/how-to-create-a-simple-multi-item-slider/">http://tympanus.net/</a></p>
				<p><a class="thickbox" href="'.__PS_BASE_URI__.'modules/homecategoriesplus/samples.jpg"><img src="'.$this->_path.'samples-small.jpg" width="200" height="213" alt="Homecategoriesplus by Ckarone" /></a>
		  		</p>
			</fieldset>
		</form>';
		return $output;
	}

	function hookHome($params)
    {
        global $smarty;
		//Looking for PS version in order to be compatible with 1.4 & 1.5
		if(substr(_PS_VERSION_, 0, 3) == '1.4'){
		$level = 1;
		$ordre_cat = "ORDER BY c.`position` ASC";
		$ordre_join = "";
		}else{
		//For 1.5
		$level = 2;
		$ordre_cat = "ORDER BY cs.`position` ASC";
		$ordre_join = "LEFT JOIN "._DB_PREFIX_."category_shop cs ON (cs.`id_category` = c.`id_category` AND cs.`id_shop` = ".(int)$this->context->shop->id.")";
  		}
		
		$id_customer = (int)$params['cookie']->id_customer;
		$id_group = $id_customer ? Customer::getDefaultGroupId($id_customer) : _PS_DEFAULT_CUSTOMER_GROUP_;
		$id_lang = (int)($params['cookie']->id_lang);
		//Set the date
	  	$now = date('Y-m-d H:i:s');
		//Looking for hidden categories (can be set in the BO)
		if(Configuration::get('HOME_cat_plus__selcat') && Configuration::get('HOME_cat_plus__selcat')!=''){
			$hiddencat = explode(',' ,Configuration::get('HOME_cat_plus__selcat'));
			$filtrecat='';
			foreach($hiddencat AS $val => $valeur)
	  		{
	  		$filtrecat.= "AND c.`id_category` !=".$valeur." ";
			}
		}else{
		$filtrecat='';
		}
		
 		$mycategories = array();
		//Looking for the top categories with a limit (can be set in the BO)
		$result_1 = Db::getInstance()->ExecuteS("SELECT * FROM "._DB_PREFIX_."category c
		LEFT JOIN "._DB_PREFIX_."category_lang cl ON (c.`id_category` = cl.`id_category`)
		LEFT JOIN "._DB_PREFIX_."category_group cg ON (cg.`id_category` = c.`id_category`)
		".$ordre_join."
		WHERE c.active = 1 ".$filtrecat."
		AND c.level_depth = ".$level."
		AND cl.id_lang = ".$id_lang."
		AND cg.id_group = ".$id_group."
		".$ordre_cat."
		LIMIT ".(int)Configuration::get('HOME_cat_plus__NBR')."");
		foreach ($result_1 as $cat)
		{
			$caTg = array();
			$caTg['id'] = $cat['id_category'];
			$caTg['titre'] = preg_replace('/^[0-9]+\./', '', $cat['name']);
			$caTg['link_rewrite'] = $cat['link_rewrite'];
			
			//Looking for the latest product category
			if(Configuration::get('HOME_cat_plus__product_odr') == 1)
			$order_prod ='p.date_add DESC';
			else if (Configuration::get('HOME_cat_plus__product_odr') == 2)
			$order_prod ='cp.position ASC';
			else if (Configuration::get('HOME_cat_plus__product_odr') == 3)
			$order_prod ='RAND()';
			else if (Configuration::get('HOME_cat_plus__product_odr') == 4)
			$order_prod ='p.date_upd DESC';
			$result_3 = Db::getInstance()->ExecuteS("SELECT p.*, p.id_product as myid, pi.id_image, pl.name, pl.link_rewrite,pl.id_product, pl.id_lang, (p.`price` * IF(t.`rate`,((100 + (t.`rate`))/100),1)) AS orderprice 
			FROM "._DB_PREFIX_."category_product cp 
			LEFT JOIN "._DB_PREFIX_."category c ON (c.`id_category` = cp.`id_category`)
			LEFT JOIN "._DB_PREFIX_."product p ON (p.`id_product` = cp.`id_product`)
			LEFT JOIN "._DB_PREFIX_."image pi ON (p.`id_product` =  pi.`id_product` AND pi.`cover` = 1)
			LEFT JOIN "._DB_PREFIX_."product_lang pl ON (p.`id_product` = pl.`id_product` AND pl.`id_lang` = '".$id_lang."')
			LEFT JOIN "._DB_PREFIX_."tax t ON t.`id_tax` = p.`id_tax_rules_group`
			LEFT JOIN "._DB_PREFIX_."tax_lang tl ON (t.`id_tax` = tl.`id_tax` AND tl.`id_lang` = '".$id_lang."')
			WHERE cp.`id_category` = ".$cat['id_category']." OR c.nleft >= ".$cat['nleft']." AND c.nright <= ".$cat['nright']."
			AND p.`active` = 1 
			ORDER BY ".$order_prod."
			LIMIT 0,".Configuration::get('HOME_cat_plus__sub10')."");
			$myproduct = array();
				foreach ($result_3 as $pro)
				{
					$product = array();
					$product['id'] = $pro['id_product'];
					$product['titre'] = $pro['name'];
					$product['link_rewrite'] = $pro['link_rewrite'];
					$product['id_image'] = $pro['id_product'].'-'.$pro['id_image'];
					$product['price'] = $pro['orderprice'];
					$product['quantity'] = $pro['quantity'];
					$product['on_sale'] = $pro['on_sale'];
					$product['show_price'] = $pro['show_price'];
					$product['online_only'] = $pro['online_only'];
					$product['available_for_order'] = $pro['available_for_order'];
					$product['price_tax_exc'] = Product::getPriceStatic($product['id'],false);
					$product['price'] = Product::getPriceStatic($product['id'],true);
						//Looking for price reduction
						if ( (isset($pro['id_product'])) && ($pro['id_product'] <> '')){
						$product['new_price'] = '';
						$result_4 = Db::getInstance()->ExecuteS('SELECT * 
						FROM '._DB_PREFIX_.'specific_price
						WHERE id_product = '.$pro['id_product'].' 
						AND (`from` = \'0000-00-00 00:00:00\' OR (\''.$now.'\' >= `from` AND \''.$now.'\' <= `to`)) 
						LIMIT 1');
							//If a price reduction exist
							if($result_4 <> 0){
							$product['new_price'] = '';
								foreach ($result_4 as $rows){
								$product['reduction_price'] = $rows['reduction'];
								$product['reduction_type'] = $rows['reduction_type'];
									
									//Product price with reduction
									if($product['reduction_type'] == 'percentage'){
										$product['new_price'] = round($product['price']-($product['price']*$product['reduction_price']), 2);	
										$product['reduction_price'] =  $product['reduction_price']*100;
									}else{
										$product['new_price'] = round($product['price']-$product['reduction_price'],0);
										$product['new_price'] = Product::getPriceStatic($pro['id_product'],true);
									}	
								}
							}
						}
					    
					array_push($myproduct,$product);
					 $caTg['prod'] = $myproduct;
				}
						//Looking for PS version in order to be compatible with 1.5 multistore mode
						if(substr(_PS_VERSION_, 0, 3) == '1.4'){
	  						$thelang = $id_lang; 
	  					}else{
							$thelang = $id_lang.Shop::addSqlRestrictionOnLang('cl');
						}
						$result_2 = Db::getInstance()->ExecuteS("SELECT * FROM "._DB_PREFIX_."category c
						LEFT JOIN "._DB_PREFIX_."category_lang cl ON (c.`id_category` = cl.`id_category`)
						LEFT JOIN "._DB_PREFIX_."category_group cg ON (cg.`id_category` = c.`id_category`)
						".$ordre_join."
						WHERE c.`id_parent` = '".$cat['id_category']."' 
						AND c.`active` = 1 ".$filtrecat."
						AND cl.`id_lang` = '".$thelang."' 
						AND cg.`id_group` = ".$id_group." 
						".$ordre_cat."
						LIMIT ".(int)Configuration::get('HOME_cat_plus__NBR')."");

						$mysubcategories = array();
						foreach ($result_2 as $for)
						{
							$caTs = array();
							$caTs['id'] = $for['id_category'];
							$caTs['titre'] = substr(preg_replace('/^[0-9]+\./', '', $for['name']),0,(int)Configuration::get('HOME_cat_plus__sub3')); 
							$caTs['link_rewrite'] = $for['link_rewrite'];
							array_push($mysubcategories,$caTs);
							$caTg['subs'] = $mysubcategories;
						}
			array_push($mycategories,$caTg);
		}
	 $smarty->assign(array(
	 'allow_buy_when_out_of_stock' => Configuration::get('PS_ORDER_OUT_OF_STOCK', false),
	 'categories' => $mycategories,
	 'displayprod' => (int)Configuration::get('HOME_cat_plus__product'),
	 'displaycat' => (int)Configuration::get('HOME_cat_plus__cat'),
	 'displaybtn' => (int)Configuration::get('HOME_cat_plus__product_btn'),
	 'displayprice' => (int)Configuration::get('HOME_cat_plus__product_price'),
	 'displaycatimg' => (int)Configuration::get('HOME_cat_plus__cat_img'),
	 'displaysubcatimg' => (int)Configuration::get('HOME_cat_plus__subcat_img'),
	 'displaysub7' => (int)Configuration::get('HOME_cat_plus__sub7'),
	 'jquery' => (int)Configuration::get('HOME_cat_plus__sub13'),
	 'jquerylink' => (int)Configuration::get('HOME_cat_plus__sub14')
	 ));
     return $this->display(__FILE__, 'homecategoriesplus.tpl');
	}
	//Add the CSS to the header
		public function hookHeader($params)
	{
  		 global $smarty;
		if(Configuration::get('HOME_cat_plus__sub5') ==1)
		$displaysub5 = 'underline';
			else 
			$displaysub5 = 'none';

	 $smarty->assign(array(
	 'divsize' => (int)Configuration::get('HOME_cat_plus__NBR_size'),
	 'divsizeh' => (int)Configuration::get('HOME_cat_plus__NBR_size_h'),
	 'prod_marg' => (int)Configuration::get('HOME_cat_plus__NBR_marg_p'),
	 'divcolor' => Configuration::get('HOME_cat_plus__NBR_size_l'),
	 'displaycatbor' => (int)Configuration::get('HOME_cat_plus__blockb'),
	 'displaycatborc' => Configuration::get('HOME_cat_plus__blockbc'),
	 'displayprodbor' => (int)Configuration::get('HOME_cat_plus__product_b'),
	 'displayprodborc' => Configuration::get('HOME_cat_plus__product_bc'),
	 'displaysub1' => Configuration::get('HOME_cat_plus__sub1'),
	 'displaysub2' => Configuration::get('HOME_cat_plus__sub2'),
	 'displaysub4' => Configuration::get('HOME_cat_plus__sub4'),
	 'displaysub5' => $displaysub5,
	 'displaysub6' => Configuration::get('HOME_cat_plus__sub6'),
	 'displaysub8' => Configuration::get('HOME_cat_plus__sub8'),
	 'displaysub9' => Configuration::get('HOME_cat_plus__sub9'),
	 'displaysub11' => Configuration::get('HOME_cat_plus__sub11'),
	 'displaysub12' => Configuration::get('HOME_cat_plus__sub12'),
	 'displaysub15' => Configuration::get('HOME_cat_plus__sub15'),
	 'displaysub16' => Configuration::get('HOME_cat_plus__sub16'),
	 'displaysub17' => Configuration::get('HOME_cat_plus__sub17'),
	 'displaysub18' => Configuration::get('HOME_cat_plus__sub18'),
	 'displaysub19' => Configuration::get('HOME_cat_plus__sub19'),
	 'displaysub20' => Configuration::get('HOME_cat_plus__sub20'),
	 'modulewidth' => Configuration::get('HOME_cat_plus__NBR_mw')
	 ));
     return $this->display(__FILE__, 'catpluscss.tpl');
	
			Tools::addCSS(($this->_path).'catplus.css');
	}
}
?>